

// bitmap to byte message on the timer screen

const int study_minutes = 0;
const int short_break_minutes = 5;
const int long_break_minutes = 15;


static const unsigned char PROGMEM image_paint_0_bits[] = {0x0c,0x00,0x0a,0x00,0x0a,0x00,0xbe,0x40,0xff,0xe0,0xff,0xe0,0x7f,0xe0,0x7f,0xe0,0x7f,0xc0,0x7f,0xc0,0x7f,0xc0,0x7f,0x80,0x7f,0x00,0x7c,0x00,0xf8,0x00,0x80,0x00};
static const unsigned char PROGMEM image_paint_1_bits[] = {0x91,0xe4,0x81,0x87,0xbe,0x71,0x24,0x83,0x04,0x88,0x21,0x24,0x82,0x04,0x88,0x21,0xe3,0x82,0xe4,0x88,0x21,0xe0,0x03,0xc7,0x88,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7f,0x24,0xe0,0x00,0x00,0x09,0x24,0x80,0x00,0x00,0x09,0xe4,0xe0,0x00,0x00,0x09,0x34,0x20,0x00,0x00,0x09,0x34,0xe0,0x00};
static const unsigned char PROGMEM image_paint_2_bits[] = {0x00,0x00,0x40,0x22,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xc3,0x80,0x30,0x00,0x02,0x02,0x50,0x00,0x00,0x02,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x62,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x00,0x00,0x00,0x10,0x00,0x00};
static const unsigned char PROGMEM image_paint_3_bits[] = {0x90,0x60};

static const unsigned char PROGMEM image_paint_5_bits[] = {0x80,0xe0,0xb0,0x8c,0x86,0x8e,0x98,0xf0,0xc0};
static const unsigned char PROGMEM image_paint_6_bits[] = {0xe1,0xc0,0xa1,0x40,0xa1,0x40,0xa1,0x40,0xa1,0x40,0xa1,0x40,0xa1,0x40,0xa1,0x40,0xe1,0xc0};

// timer icons


#include <Adafruit_GFX.h>         // Core graphics library
#include <Adafruit_ILI9341.h>     // Hardware-specific library
#include <SdFat.h>                // SD card & FAT filesystem library
#include <Adafruit_SPIFlash.h>    // SPI / QSPI flash library
#include <Adafruit_ImageReader.h> // Image-reading functions

#include <WiFi.h>
#include <HTTPClient.h>
#include <Arduino_JSON.h>

#include <NTPClient.h>
#include <WiFiUdp.h>

#include <TouchScreen.h>

//Touchscreen X+ X- Y+ Y- pins
#define YP A5  // must be an analog pin, use "An" notation!
#define XM A4  // must be an analog pin, use "An" notation!
#define YM 14   // can be a digital pin
#define XP 12   // can be a digital pin

TouchScreen ts = TouchScreen(XP, YP, XM, YM, 300);

String alternative;

String weekDays[7]={"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"};
String months[12]={"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
static const unsigned char PROGMEM image_weather_temperature_bits[] = {0x1c,0x00,0x22,0x02,0x2b,0x05,0x2a,0x02,0x2b,0x38,0x2a,0x60,0x2b,0x40,0x2a,0x40,0x2a,0x60,0x49,0x38,0x9c,0x80,0xae,0x80,0xbe,0x80,0x9c,0x80,0x41,0x00,0x3e,0x00};
static const unsigned char PROGMEM image_wifi_full_bits[] = {0x01,0xf0,0x00,0x07,0xfc,0x00,0x1e,0x0f,0x00,0x39,0xf3,0x80,0x77,0xfd,0xc0,0xef,0x1e,0xe0,0x5c,0xe7,0x40,0x3b,0xfb,0x80,0x17,0x1d,0x00,0x0e,0xee,0x00,0x05,0xf4,0x00,0x03,0xb8,0x00,0x01,0x50,0x00,0x00,0xe0,0x00,0x00,0x40,0x00,0x00,0x00,0x00};

// This is calibration data for the raw touch data to the screen coordinates
#define TS_MINX -2300
#define TS_MINY -2600
#define TS_MAXX 400
#define TS_MAXY 500

#define MINPRESSURE -1000
#define MAXPRESSURE 0


// Comment out the next line to load from SPI/QSPI flash instead of SD card:
#define USE_SD_CARD

// Pin definitions for 2.4" TFT FeatherWing vary among boards...

#if defined(ESP8266)
  #define TFT_CS   5
  #define TFT_DC   17
  #define SD_CS    2
#elif defined(ESP32) && !defined(ARDUINO_ADAFRUIT_FEATHER_ESP32S2)
  #define TFT_CS   5
  #define TFT_DC   17
  #define SD_CS    16

#else // Anything else!
  #define TFT_CS   5
  #define TFT_DC   17
  #define SD_CS    16
#endif

#if defined(USE_SD_CARD)
  SdFat                SD;         // SD card filesystem
  Adafruit_ImageReader reader(SD); // Image-reader object, pass in SD filesys
#else
  // SPI or QSPI flash filesystem (i.e. CIRCUITPY drive)
  #if defined(__SAMD51__) || defined(NRF52840_XXAA)
    Adafruit_FlashTransport_QSPI flashTransport(PIN_QSPI_SCK, PIN_QSPI_CS,
      PIN_QSPI_IO0, PIN_QSPI_IO1, PIN_QSPI_IO2, PIN_QSPI_IO3);
  #else
    #if (SPI_INTERFACES_COUNT == 1)
      Adafruit_FlashTransport_SPI flashTransport(SS, &SPI);
    #else
      Adafruit_FlashTransport_SPI flashTransport(SS1, &SPI1);
    #endif
  #endif
  Adafruit_SPIFlash    flash(&flashTransport);
  FatVolume        filesys;
  Adafruit_ImageReader reader(filesys); // Image-reader, pass in flash filesys
#endif

Adafruit_ILI9341       tft    = Adafruit_ILI9341(TFT_CS, TFT_DC);
Adafruit_Image         img;        // An image loaded into RAM
int32_t                width  = 0, // BMP image dimensions
                       height = 0;


void timer();

const char* ssid = "CLSLabs";
const char* password = "clshawks";

// Your Domain name with URL path or IP address with path
String openWeatherMapApiKey = "e0f21e445c4ebf1aec3b6ebab38b7261";
// Example:
//String openWeatherMapApiKey = "bd939aa3d23ff33d3c8f5dd1dd435";

// Replace with your country code and city
String city = "Charlotte";
String countryCode = "US";

// THE DEFAULT TIMER IS SET TO 10 SECONDS FOR TESTING PURPOSES
// For a final application, check the API call limits per hour/minute to avoid getting blocked/banned
unsigned long lastTime = 0;
// Timer set to 10 minutes (600000)
//unsigned long timerDelay = 600000;
// Set timer to 10 seconds (10000)
unsigned long timerDelay = 10000;

String jsonBuffer;


WiFiUDP ntpUDP;
NTPClient timeClient(ntpUDP);


void setup(void) {

  ImageReturnCode stat; // Status from image-reading functions

  Serial.begin(9600);
  while(!Serial)  delay(100);       // Wait for Serial Monitor before continuing

  tft.begin();          // Initialize screen

  // The Adafruit_ImageReader constructor call (above, before setup())
  // accepts an uninitialized SdFat or FatVolume object. This MUST
  // BE INITIALIZED before using any of the image reader functions!
  Serial.print(F("Initializing filesystem..."));
#if defined(USE_SD_CARD)
  // SD card is pretty straightforward, a single call...
  if(!SD.begin(SD_CS, SD_SCK_MHZ(25))) { // ESP32 requires 25 MHz limit
    Serial.println(F("SD begin() failed"));
    for(;;); // Fatal error, do not continue
  }
#else
  // SPI or QSPI flash requires two steps, one to access the bare flash
  // memory itself, then the second to access the filesystem within...
  if(!flash.begin()) {
    Serial.println(F("flash begin() failed"));
    for(;;);
  }
  if(!filesys.begin(&flash)) {
    Serial.println(F("filesys begin() failed"));
    for(;;);
  }
#endif
  Serial.println(F("OK!"));

  // Fill screen blue. Not a required step, this just shows that we're
  // successfully communicating with the screen.


  // Load full-screen BMP file 'purple.bmp' at position (0,0) (top left).
  // Notice the 'reader' object performs this, with 'tft' as an argument.
  Serial.print(F("Loading weather.bmp to screen..."));
  tft.fillScreen(ILI9341_BLACK);
  //stat = reader.drawBMP("/01d.bmp", tft, 0, 0);
  // (Absolute path isn't necessary on most devices, but something
  // with the ESP32 SD library seems to require it.)
  //reader.printStatus(stat);   // How'd we do?


  delay(2000); // Pause 2 seconds before moving on to loop()
  WiFi.begin(ssid, password);
  timeClient.begin();
  timeClient.setTimeOffset(-14400);
  Serial.println("Connecting");
  while(WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.print("Connected to WiFi network with IP Address: ");
  Serial.println(WiFi.localIP());
  


}

void loop() {
  TSPoint p = ts.getPoint();
  p.x = map(p.x, TS_MINY, TS_MAXY, 0, 240);
  p.y = map(p.y, TS_MINX, TS_MAXX, 0, 320);


 // if (p.x >= 135 && p.x <= 200 && p.y >=195 && p.y <=330) {
  if (p.x >= 180 && p.x <= 210 && p.y >=-10 && p.y <=80) {

    tft.fillScreen(0);

    reader.drawBMP("/tom.bmp", tft, 0, 0);
      
          
    tft.fillRoundRect(44, 37, 55, 29, 4, 0xFFFF);
    tft.drawBitmap(76, 57, image_paint_0_bits, 11, 16, 0xFFFF);
    tft.drawBitmap(51, 45, image_paint_1_bits, 39, 13, 0x0);
    tft.drawBitmap(59, 45, image_paint_2_bits, 31, 13, 0xFFFF);
    tft.drawBitmap(64, 48, image_paint_3_bits, 4, 2, 0x0);
tft.drawCircle(178, 117, 10, 0xFFFF);
tft.drawBitmap(175, 113, image_paint_5_bits, 7, 9, 0xFFFF);
tft.drawCircle(225, 117, 10, 0xFFFF);
tft.drawBitmap(220, 113, image_paint_6_bits, 10, 9, 0xFFFF);






    tft.setCursor(140, 60);

    tft.setTextColor(ILI9341_WHITE);
    tft.drawRoundRect(130, 50, 140, 48, 5, ILI9341_WHITE);
   // tft.println("25:00");
   while(true) {
   
    TSPoint p = ts.getPoint();
      p.x = map(p.x, TS_MINY, TS_MAXY, 0, 240);
p.y = map(p.y, TS_MINX, TS_MAXX, 0, 320);

  if (p.x >= 120 && p.x <= 165 && p.y >=170 && p.y <=200) {
    timer();

  }

  }
  
  }
  

     

    delay(1000); // Pause 1 sec.
    if ((millis() - lastTime) > timerDelay) {
    // Check WiFi connection status
    if(WiFi.status()== WL_CONNECTED){
      String serverPath = "http://api.openweathermap.org/data/2.5/weather?q=" + city + "," + countryCode + "&APPID=" + openWeatherMapApiKey;
      
      jsonBuffer = httpGETRequest(serverPath.c_str());
      Serial.println(jsonBuffer);
      JSONVar myObject = JSON.parse(jsonBuffer);
  
      // JSON.typeof(jsonVar) can be used to get the type of the var
      if (JSON.typeof(myObject) == "undefined") {
        Serial.println("Parsing input failed!");
        return;
      }
      



      delay(1000);
     
     
     
     
      //tft.fillScreen(ILI9341_BLACK);

      tft.setRotation(1);

      String icon = myObject["weather"][0]["icon"];
      String bmpFileName = "/" + icon + ".bmp";
      

      reader.drawBMP(bmpFileName.c_str(), tft, -10, -50);


      tft.setRotation(1);
      tft.setTextSize(3);
      tft.setTextColor(ILI9341_WHITE);
      tft.setCursor(0, 0);
      timeClient.update();
      String hour = String(timeClient.getHours());
      String minute = String(timeClient.getMinutes());
      String weekDay = weekDays[timeClient.getDay()];
      tft.println(weekDay + ",");
      tft.setCursor(80, 0);
      tft.println(hour + ":" + minute);
      if(hour.toInt() >= 12){
    alternative = "PM";
  }else{
    alternative = "AM";
  }
      tft.setTextSize(2);
      tft.setCursor(170, 0);
      tft.println(alternative);
      tft.drawBitmap(301, 4, image_weather_temperature_bits, 16, 16, 0xFFFF);
      tft.drawBitmap(276, 4, image_wifi_full_bits, 19, 16, 0xFFFF);


      tft.setTextSize(2);
      Serial.print("JSON object = ");
      Serial.println(myObject);
      tft.setCursor(0, 175);
      tft.println("Temperature: ");
      tft.setCursor(150, 175);
      int temp = myObject["main"]["temp"]; 
       int new_temp = (temp - 273.15)*9/5 + 32;
       tft.println(new_temp);
       tft.setCursor (165, 175);  tft.println("  deg. F");
      Serial.print("Pressure: ");
      Serial.println(myObject["main"]["pressure"]);
      tft.setCursor(0, 195);
      tft.println("Humidity: ");
      tft.setCursor(110, 195);
      tft.println(myObject["main"]["humidity"]);
      tft.setCursor(0, 215);
      tft.println("Wind: ");
      tft.setCursor(65, 215);
      tft.println(myObject["wind"]["speed"]);
      tft.setCursor(155, 215);
      tft.println(city + ", " + countryCode);
   // taken from circuit python :D  weather = json.loads(weather)
     // weather_icon = weather['weather'][0]['icon']
      //self.set_icon("/sd/icons/"+weather_icon+".bmp")
      tft.drawRoundRect(5, 35, 90, 25, 4, ILI9341_WHITE);
      tft.fillRoundRect(5, 35, 90, 25, 4, ILI9341_WHITE);
      tft.setCursor(20, 45);
      tft.setTextSize(1);
      tft.setTextColor(ILI9341_BLACK);
      tft.println("POMO TIME!");


          
        
      
      

      
    }
    else {

      tft.setCursor(45, 20);
      tft.println("WiFi Disconnected");
    }
    lastTime = millis();
  }
}


String httpGETRequest(const char* serverName) {
  WiFiClient client;
  HTTPClient http;
    
  // Your Domain name with URL path or IP address with path
  http.begin(client, serverName);
  
  // Send HTTP POST request
  int httpResponseCode = http.GET();
  
  String payload = "{}"; 
  
  if (httpResponseCode>0) {
    Serial.print("HTTP Response code: ");
    Serial.println(httpResponseCode);
    payload = http.getString();
  }
  else {
    Serial.print("Error code: ");
    Serial.println(httpResponseCode);
  }
  // Free resources
  http.end();

  return payload;
}



void timer() {


      int seconds = 0;
      
    int minutes = 25;
    int minutesstudied = 0;
      tft.setCursor(0, 215);
      tft.setTextSize(2);


    tft.println("Total time studied: ");
    

    // count up and display the timer during study period
    //  if (p.x >= 140 && p.x <= 165 && p.y >=170 && p.y <=190) {


        Serial.println("received!");
    

        while(minutes>=study_minutes){ // keep counting until we've reached the time limit for a study session
        


          // print out the timer value in mm:ss format 
          while (minutes > 0 || seconds > 0) {
            
            tft.setTextSize(2);
            tft.fillRoundRect(230, 215, 60, 50, 5, 0x2946);
             tft.setCursor(230, 215);

             tft.println(minutesstudied);
                  tft.setTextSize(4);
            tft.setCursor(140, 60);
            if(minutes<10){  // if minutes is less than 10, we need to print an extra 0 to the display
              tft.println("0");
              tft.setCursor(165, 60);
              tft.println(minutes);

            } else {
            tft.setCursor(140, 60);
            tft.println(minutes);
            }
            tft.setCursor(190, 60);
            tft.println(":");
            if(seconds<10){  // if seconds is less than 10, we need to print an extra 0 to the display
              tft.setCursor(215, 60);
              tft.println("0");
              tft.setCursor(240, 60);
              tft.println(seconds);
            } else {
            tft.setCursor(215, 60);
            tft.println(seconds);
            }
            // wait for one second then increment the second counter
            delay(1000);


            
            tft.fillRoundRect(130, 50, 140, 48, 5, 0x2946);
            tft.drawRoundRect(130, 50, 140, 48, 5, ILI9341_WHITE);
            seconds--;
            if (seconds < 0) {
            seconds = 59; 
          
          // increment the minute counter after 60 seconds have elapsed

          minutesstudied ++;
          minutes--; 



          }


            }  
  }

}




